unit uXmlParser1; { mk, 12.4.04 }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, xmldom, XMLIntf, StdCtrls, msxmldom, XMLDoc;

type
  TForm1 = class(TForm)
    XMLDocument1: TXMLDocument;
    bGibaus: TButton;
    mAusgabe: TMemo;
    OpenDialog1: TOpenDialog;
    procedure bGibausClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.bGibausClick(Sender: TObject);
var
  node  : IXMLNode;
  r     : integer;

  function leer(r : integer) : string;
  var
    s : string;
    i : integer;
  begin
    s := ''; for i := 1 to r do s := s+' ';
    result := s;
  end;

  procedure gibaus(node : IXMLNode);
  var
    nodes : IXMLNodeList;
    i     : integer;
  begin
    if node.IsTextElement
    then
      mAusgabe.Lines.Add(leer(r)+node.text)
    else
    begin
      mAusgabe.Lines.Add(leer(r)+node.NodeName);
      if node.HasChildNodes then
      begin
        r := r + 3;
        nodes := node.ChildNodes;
        for i := 0 to nodes.Count - 1 do
          gibaus(nodes[i]);
        r := r - 3;
      end;
    end;
  end;

begin
  if OpenDialog1.Execute then
  begin
    XMLDocument1.LoadFromFile(OpenDialog1.FileName);
    r := 0;
    node := XMLDocument1.DocumentElement;
    gibaus(node);
  end;
end;

end.
